"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.generateRandomString = exports.sha512 = exports.sha1 = void 0;
const crypto_1 = __importDefault(require("crypto"));
const sha1 = (originVal, salt) => {
    if (salt) {
        return crypto_1.default.createHmac('sha1', salt).update(originVal).digest('hex');
    }
    return crypto_1.default.createHash('sha1').update(originVal).digest('hex');
};
exports.sha1 = sha1;
const sha512 = (originVal, salt) => {
    if (salt) {
        return crypto_1.default.createHmac('sha512', salt).update(originVal).digest('hex');
    }
    return crypto_1.default.createHash('sha512').update(originVal).digest('hex');
};
exports.sha512 = sha512;
const generateRandomString = (length = 10) => crypto_1.default
    .randomBytes(Math.ceil(length / 2))
    .toString('hex')
    .slice(0, length);
exports.generateRandomString = generateRandomString;
//# sourceMappingURL=index.js.map